#!/bin/sh
#
# start duchamp for the current platform
#
TOPDIR="/nfs/atapplic/duchamp/"
BINARY="Duchamp"

Fail () { while [ $# -gt 0 ] ; do echo $1; shift ; done; exit 1; } ;

### NB: the following does not allow options to be passed.
## fixme allow a version number as the argument, then shift it off the arglist
#if [ $# -gt 0 ] ; then
#    VERSION=$1; shift
#    TOPDIR=${TOPDIR}-${VERSION}
#fi

case `uname` in
    Linux) 
	case `uname -m` in
	    *86)
		PLATFORM=linux 
		;;
	    *86_64)
		PLATFORM=linux64
		;;
	esac
	;;
    SunOS)
	case `uname -r` in
	    4.)
		PLATFORM=sun4
		;;
	    5.*)
		PLATFORM=sun4sol
		;;
	    *)
		case `uname -m` in
		    *86)
			PLATFORM=i86sol 
			;;
		    esac
		esac
	;;
    Darwin)
	case `uname -m` in
	    i*86)
		PLATFORM=darwin_x86
		;;
	    Power*)
		PLATFORM=darwin_ppc
		;;
	esac
	;;
    *)
	Fail "Unsupported on the `uname` platform"
esac

# fixme: do we need to diddle with LD_LIBRARY_PATH
#if so, use this to get the directories:
#echo $LD_LIBRARY_PATH

BuildDir="${TOPDIR}/${PLATFORM}/Duchamp*"

LD_LIBRARY_PATH=${LD_LIBRARY_PATH}`grep "\-L" ${BuildDir}/Makefile | awk '{for(i=1;i<=NF;i++) if(substr($i,1,2)=="-L") printf ":%s", substr($i,3,length($i)-2)}END{printf "\n"}'`

#echo $LD_LIBRARY_PATH


FULL_BINARY="${TOPDIR}/${PLATFORM}/bin/${BINARY}"
#echo Full binary = ${FULL_BINARY}
#echo "args = $@"


# The $@ is the remaininng arguments from the command line
exec $FULL_BINARY $@

